<!DOCTYPE html>
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>FPM: XTrackCAD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="Content-Style-Type" content="text/css">
    <link rel="stylesheet" href="css/fpm.css" type="text/css">
    <link rel="Icon" href="im/fpm.png" type="image/png">
    <link rel="Start" title="FPM Home" href="index.html">
  </head>
  <body>
    <table style="width: 100%;">
      <tbody>
        <tr>
          <td class="titol" style="vertical-align: top;">
            <h1 style="text-align: center;">XTrackCAD</h1>
          </td>
        </tr>
        <tr>
          <td class="index-cap" style="vertical-align: top;">
            <h2>Índex / Index</h2>
          </td>
        </tr>
        <tr>
          <td class="index-fons" style="vertical-align: top;">
            <ul>
              <li><a href="#general" class="intern">General</a></li>
              <li><a href="#documentacio" class="intern">Documentació /
                  Documentation</a></li>
              <li><a href="#installacio" class="intern">Instal·lació /
                  Installation</a></li>
              <li><a href="#us" class="intern">Ús / Usage</a></li>
              <li><a href="#trens" class="intern">Trens / Trains</a></li>
              <li><a href="#3d" class="intern">3D</a></li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="general-cap" style="vertical-align: top;">
            <h2><a id="general">General</a></h2>
          </td>
        </tr>
        <tr>
          <td class="general-fons" style="vertical-align: top;">
            <ul>
              <li><a href="modelisme.html" class="intern">Modelisme</a></li>
              <li><a href="circuits.html" class="intern">Circuits / Layouts</a></li>
              <li><a href="http://www.xtrkcad.org/">XTrackCAD</a></li>
              <li><a href="https://sourceforge.net/projects/xtrkcad-fork/">XTrkCAD
Model
                  RR Track Planner</a> (Sourceforge)
                <ul>
                  <li><a href="https://sourceforge.net/p/xtrkcad-fork/_list/tickets?source=navbar">Tickets</a>
                    <ul>
                      <li><a name="xtrkcad_feature_requests">Feature requests </a>
                        <ul>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/feature-requests/1/">#1
Extended
                              DXF export features</a> </li>
                        </ul>
                      </li>
                      <li><a name="xtrackcad_bugs"></a>Bugs
                        <ul>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/bugs/428/">#428
                              Cannot disable rulers when printing</a></li>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/bugs/423/">#423
                              Line artifacts when printing</a> (fixed)<a href="https://sourceforge.net/p/xtrkcad-fork/bugs/423/">
                            </a></li>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/bugs/215/">#215
                              Track elevations not displayed</a> (fixed)</li>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/bugs/206/">#206
                              Errors when printing at scale other than 1</a>
                            (fixed) </li>
                          <li><a name="xtrackcad_bugs_204"></a><a href="https://sourceforge.net/p/xtrkcad-fork/bugs/204/">#204
                              undefined reference to `_itoa'</a> (fixed) </li>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/bugs/202/">#202
                              Errors in rocon.xtp</a> (fixed) </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                  <li>Files (File / Parameter files / Browse)
                    <ul>
                      <li>/usr/local/share/xtrkcad/<a href="https://sourceforge.net/p/xtrkcad-fork/xtrkcad/ci/default/tree/app/lib/params/">params</a>/
                        <ul>
                          <li>flnpicco.xtp (<a class="intern" href="modelisme.html#fleischmann">Fleischmann</a>
                            Piccolo 9xxx) </li>
                          <li><span style="text-decoration: line-through;">rocon.xtp</span>
                            (Roco 22xxx) (2017-10-15: replaced by N-fl.xtp) </li>
                          <li>N-fl.xtp (fpm) (<a class="intern" href="modelime.html#vies_fleischmann_222">Fleischmann
                              222xx</a>) </li>
                        </ul>
                      </li>
                      <li>usuari / user
                        <ul>
                          <li>Custom structures (STRUCTURE), prototypes
                            (CARPROTO), turnouts (TURNOUT)
                            <ul>
                              <li>Manage -&gt; Custom defined parts</li>
                              <li>~/.xtrkcad/xtrackcad.cus</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li>...</li>
                    </ul>
                  </li>
                </ul>
              </li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="seccio-cap" style="vertical-align: top;">
            <h2><a id="documentacio">Documentació / Documentation</a></h2>
          </td>
        </tr>
        <tr>
          <td class="seccio-fons" style="vertical-align: top;">
            <ul>
              <li><a href="#xtrkcad_us" class="intern">Ús / Usage</a></li>
              <li><a href="http://www.plataforma-n.com/index.php?topic=18482.0">Problema
tamaño
                  Roco 22207 xtrkCAD AVISO a USUARIOS DEL PROGRAMA</a></li>
              <li>Reviews
                <ul>
                  <li><a href="https://www.newrailwaymodellers.co.uk/xtrkcad.htm">XTrkCad
                      - Model Railway/Railroad Layout Design Software</a>
                    <ul>
                      <li>downloadable examples</li>
                    </ul>
                  </li>
                </ul>
              </li>
            </ul>
            <ul>
              <li><a href="http://www.xtrkcad.org/Wikka/FileFormats">File
                  formats</a>
                <ul>
                  <li>U: information from turnout designer
                    <ul>
                      <li><code>U "Regular turnout" "" "&lt;manufacturer&gt;"
                          "&lt;left_description&gt;" "#_left"
                          "&lt;right_description&gt;" "#_right" &lt;length&gt;
                          &lt;angle&gt; &lt;height&gt; &lt;length&gt;
                          &lt;roadbed_width&gt; &lt;line_width&gt;
                          &lt;colour&gt;</code> </li>
                    </ul>
                  </li>
                  <li>E: unconnected end points </li>
                  <li>S: straight track segment </li>
                  <li>C: curved track segment</li>
                </ul>
              </li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="seccio-cap" style="vertical-align: top;">
            <h2><a id="installacio">Instal·lació / Installation</a></h2>
          </td>
        </tr>
        <tr>
          <td class="seccio-fons" style="vertical-align: top;">
            <ul>
              <li>rpm
                <ul>
                  <li><a class="intern" href="linux.html#mageia">Mageia</a>
                    <ul>
                      <li><a href="https://sourceforge.net/projects/xtrkcad-fork/files/XTrackCad/">download
                          rpm</a><br>
                        <code></code></li>
                      <li><code>urpmi <a href="https://sourceforge.net/projects/xtrkcad-fork/files/XTrackCad/Version%204.3.0/">xtrkcad-setup-4.3.0-1.i686.rpm</a></code></li>
                      <li>Problemes / Problems
                        <ul>
                          <li>Un paquet demanat no es pot instal·lar:<br>
                            xtrkcad-4.3.0-1.i686 (a causa de webkitgtk no
                            satisfetes) </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>sh
                <ul>
                  <li><a href="https://sourceforge.net/projects/xtrkcad-fork/files/XTrackCad/Version%204.3.0/xtrkcad-setup-4.3.0-1.i686.sh/download">xtrkcad-setup-4.3.0-1.i686.sh</a></li>
                  <li>chmod +x xtrkcad-setup-4.3.0-1.i686.sh</li>
                  <li>./xtrkcad-setup-4.3.0-1.i686.sh</li>
                  <li>xtrkcad-setup-4.3.0-1.i686/bin/xtrkcad </li>
                  <li>Problemes / Problems
                    <ul>
                      <li>./xtrkcad: error while loading shared libraries:
                        libgtk-x11-2.0.so.0: cannot open shared object file: No
                        such file or directory </li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>tgz
                <ul>
                  <li><a href="https://sourceforge.net/projects/xtrkcad-fork/files/XTrackCad/Version%204.3.0/xtrkcad-source-4.3.0.tar.gz/download">xtrkcad-source-4.3.0.tar.gz</a></li>
                  <li>...</li>
                </ul>
              </li>
              <li>codi font / source code
                <ul>
                  <li>Baixa el codi / Download code
                    <ul>
                      <li><span style="text-decoration: line-through;"><a href="http://www.xtrkcad.org/Wikka/CurrentRelease">Current
                            release</a></span></li>
                      <li><a href="http://xtrkcad-fork.sourceforge.net/Wikka/DownloadInstall">Download
                          and install</a></li>
                      <li><a href="https://sourceforge.net/projects/xtrkcad-fork/">XTrkCAD
                          Model RR Track Planner</a> (Sourceforge)
                        <ul>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/xtrkcad/ci/default/tree/">xtrkcad</a>
                            (tree)</li>
                          <li><a class="intern" href="#xtrackcad_bugs">Bugs</a>
                          </li>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/xtrkcad/forks/"
                              id="xtrkcad_forks">Forks</a>
                            <ul>
                              <li><a href="https://sourceforge.net/u/cescp/xtrkcad-fork/ci/default/tree/">cescp
/
                                  xtrkcad-fork</a>
                                <ul>
                                  <li>DXF with elevations </li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li>Dependencies
                        <ul>
                          <li>Mageia
                            <ul>
                              <li><code>urpmi </code><code><a class="intern" href="programari.html#mercurial">mercurial</a></code></li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li>old instructions
                        <ul>
                          <li><code><a href="https://sourceforge.net/projects/xtrkcad-fork/files/XTrackCad/Version%204.3.0/xtrkcad_4_3_0.hg/download">https://sourceforge.net/projects/xtrkcad-fork/files/XTrackCad/Version%204.3.0/xtrkcad_4_3_0.hg/download</a>
                            </code></li>
                          <li><code>mkdir xtrkcad</code></li>
                          <li><code>cd xtrkcad</code></li>
                          <li><code><a class="intern" href="programari.html#mercurial">hg</a>
                              init </code></li>
                          <li><code>hg unbundle ../xtrkcad_4_3_0.hg</code> </li>
                          <li>create and edit .hg/hgrc adding these lines:
                            <ul>
                              <li class="bloc-codi"><code>[paths]<br>
                                  default =
                                  http://hg.code.sf.net/p/xtrkcad-fork/xtrkcad</code></li>
                            </ul>
                          </li>
                          <li><code>hg pull</code></li>
                          <li><code>hg update</code></li>
                        </ul>
                      </li>
                      <li>first time<span style=" font-family: monospace;"></span>
                        <ul>
                          <li><code>cd ~/src/</code></li>
                          <li><span style="font-family: monospace;">hg clone
                              http://hg.code.sf.net/p/xtrkcad-fork/xtrkcad</span></li>
                          <li><span style=" font-family: monospace;">cd xtrkcad</span></li>
                        </ul>
                      </li>
                      <li>next times<span style="  font-family: monospace;"></span>
                        <ul>
                          <li><code>cd ~/src/xtrkcad/</code></li>
                          <li><span style="font-family: monospace;">hg pull</span></li>
                          <li><span style=" font-family: monospace;">hg update </span></li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                  <li>Compilació / Compilation
                    <ul>
                      <li>Dependències / Dependencies
                        <ul>
                          <li>Mageia
                            <ul>
                              <li><code><samp>urpmi cmake</samp> task-c++-devel
                                  lib64gtk+2.0-devel lib64zip-devel
                                  lib64cmocka-devel lib64freeimage-devel
                                  inkscape</code> </li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li><a href="http://xtrkcad-fork.sourceforge.net/Wikka/BuildNotes">Build
                          notes</a>
                        <ul>
                          <li><code>cd ~/src</code></li>
                          <li><code>cd <span style=" font-family: monospace;">xtrkcad</span></code></li>
                          <li><code><span style="  font-family: monospace;">mkdir
                                build</span></code></li>
                          <li><code><span style="   font-family: monospace;">cd
                                build</span></code></li>
                          <li><code><a class="intern" href="informatica.html#cmake">ccmake</a>
                              ../</code>
                            <ul>
                              <li>c
                                <ul>
                                  <li class="bloc-codi"><code>CMAKE_BUILD_TYPE&nbsp;&nbsp;
                                      &nbsp; *Debug<br>
                                      CMAKE_INSTALL_PREFIX */usr/local<br>
                                      INTL_LIBRARY<br>
                                      LIBZIP_VERSION&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                      *1.5.2<br>
                                      XTRKCAD_USE_BROWSER&nbsp; *ON<br>
                                      XTRKCAD_USE_DOXYGEN&nbsp; *OFF<br>
                                      XTRKCAD_USE_GETTEXT&nbsp; *OFF<br>
                                      XTRKCAD_USE_GTK&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                      *ON</code></li>
                                </ul>
                              </li>
                              <li><span style="font-family: monospace;">c</span></li>
                              <li><span style=" font-family: monospace;">g</span></li>
                            </ul>
                          </li>
                          <li><span style="  font-family: monospace;">make</span></li>
                          <li><span style="   font-family: monospace;">sudo make
                              install </span>
                            <ul>
                              <ul>
                              </ul>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li>old instructions
                        <ul>
                          <li>~/src/<a href="https://sourceforge.net/p/xtrkcad-fork/xtrkcad/ci/default/tree/app/lib/Readme.md#building-xtrackcad-on-gnulinux">xtrkcad/app/lib/Readme.md</a>
                            <ul>
                              <li><code>cd [/disc]</code><br>
                                <code></code></li>
                              <li><code>mkdir -p build/</code><code>xtrkcad</code></li>
                              <li><code>cd </code><code>build/</code><code>xtrkcad</code></li>
                              <li><code><a class="intern" href="informatica.html#cmake">ccmake</a>
                                  ../../src/</code><code>xtrkcad</code>
                                <ul>
                                  <li>c
                                    <ul>
                                      <li class="bloc-codi"><code>CMAKE_BUILD_TYPE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          *Debug&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          &nbsp;<br>
                                          CMAKE_INSTALL_PREFIX&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*/usr/local&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          &nbsp;<br>
                                          INTL_LIBRARY&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*/usr/lib64/libintl.so&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          &nbsp;<br>
                                          XTRKCAD_USE_BROWSER&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*ON&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          &nbsp;<br>
                                          XTRKCAD_USE_DOXYGEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*OFF&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          &nbsp;<br>
                                          XTRKCAD_USE_GETTEXT&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
*ON&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          &nbsp;<br>
                                          XTRKCAD_USE_GTK&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                          *ON</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                        </li>
                                    </ul>
                                  </li>
                                  <li>c</li>
                                  <li>g</li>
                                </ul>
                              </li>
                              <li><code>make</code></li>
                              <li><code>sudo make install</code></li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li><a class="intern" href="programari.html#eclipse">Eclipse</a>
                        (<a href="https://cmake.org/Wiki/Eclipse_CDT4_Generator">Eclipse
                          CDT4 Generator</a>)
                        <ul>
                          <li>Dependències / Dependencies
                            <ul>
                              <li>Mageia
                                <ul>
                                  <li><code>urpmi gdb</code> </li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                          <li><code>mkdir -p build/xtrackcad_eclipse</code><br>
                            <code></code></li>
                          <li><code>cd </code><code>build/</code><code>xtrkcad_eclipse</code></li>
                          <li><code>ccmake -G"Eclipse CDT4 - Unix Makefiles" -D
                              CMAKE_BUILD_TYPE=Debug ../../src/</code><code>xtrkcad</code></li>
                          <li>launch Eclipse
                            <ul>
                              <li>Import...</li>
                              <li>C/C++ Existing code as Makefile project
                                <ul>
                                  <li>...build/xtrackcad_eclipse/ </li>
                                </ul>
                              </li>
                              <li>Toolchain:
                                <ul>
                                  <li>Linux GCC </li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li>Problemes / Problems
                        <ul>
                          <li><a class="intern" href="#xtrackcad_bugs">Bugs</a>
                          </li>
                          <li><a class="intern" href="#xtrackcad_bugs_204">.../xtrkcad/app/bin/dlayer.c:638:
undefined
                              reference to `_itoa'</a>
                            <ul>
                              <li>Solució / Solution
                                <ul>
                                  <li><a class="intern" href="#xtrackcad_bugs_204">#204:
                                      solved</a> </li>
                                  <li>app/bin/dlayer.c
                                    <ul>
                                      <li class="bloc-codi"><code>char
                                          *_itoa(long i, char* s, int
                                          dummy_radix) {<br>
                                          &nbsp;&nbsp;&nbsp; sprintf(s, "%ld",
                                          i);<br>
                                          &nbsp;&nbsp;&nbsp; return s;<br>
                                          }</code></li>
                                    </ul>
                                  </li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="seccio-cap" style="vertical-align: top;">
            <h2><a id="us">Ús / Usage</a></h2>
          </td>
        </tr>
        <tr>
          <td class="seccio-fons" style="vertical-align: top;">
            <ul>
              <li>Tutorials
                <ul>
                  <li>Help
                    <ul>
                      <li>Demos</li>
                      <li>Examples
                        <ul>
                          <li><a href="https://sourceforge.net/p/xtrkcad-fork/xtrkcad/ci/default/tree/app/lib/examples/">app/lib/examples/</a></li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                  <li><a href="http://www.xtrkcad.org/Wikka/BeginnerTutorial">Beginner's
                      tutorial</a>
                    <ul>
                      <li><a href="http://www.xtrkcad.org/Wikka/FirstLayout">Starting
a
                          plan</a></li>
                    </ul>
                  </li>
                  <li><a href="http://xtrkcad-fork.sourceforge.net/Wikka/StructureTutorial">Structure
                      Tutorial</a>
                    <ul>
                      <li>edificacions</li>
                    </ul>
                  </li>
                  <li><a href="https://www.altamontandblueridge.com/Tutorials/Planing%20Tutorial/Planning.html">Planning
                      The Altamont and Blue Ridge 2</a></li>
                </ul>
              </li>
              <li>Command line:
                <ul>
                  <li><code>xtrkcad [-v] [-l logfile] [-d
                      {logmodule}[={0,1,2,...}]] [trackfile] </code>
                    <ul>
                      <li>logmodule: init, malloc, error, command, shortPath,
                        fillElev, structure, traverseTurnout, turnout, print,
                        paramLayout, hotspot, switchmotor, ease, traverseJoint,
                        undo, pan, zoom, track, group, block, profile, curve,
                        carDlgList, carDlgState, join, modify
                        <ul>
                          <li>get all logmodule values:
                            <ul>
                              <li><code>grep LogFindIndex -R .</code></li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                      <li>Examples:
                        <ul>
                          <li><code>xtrkcad -l xtrkcad.log -d init -d track -d
                              command toto.xtc</code></li>
                          <li><code>xtrkcad -l /dev/stdout -d init -d track=4 -d
                              print toto.xtc</code></li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>Options / Layout:
                <ul>
                  <li>Scale: N </li>
                </ul>
              </li>
              <li>Preferences</li>
              <li>File / Parameter files / Browse
                <ul>
                  <li><a class="intern" href="#vies_fleischmann_222">Fleischmann
                      222xx</a>
                    <ul>
                      <li>/usr/local/share/xtrkcad/params/N-fl.xtp</li>
                    </ul>
                    <ul>
                      <li>~/xtrkcad/params/rocon_mm.xtp</li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>Custom
                <ul>
                  <li>Exemples / Examples
                    <ul>
                      <li><a href="modelisme.html#programari_fpm" class="intern">francesc.pinyol.m</a>
                        / <a href="modelisme.html#xtrkcad-custom-fpm" class="intern">xtrkcad-custom-fpm</a></li>
                    </ul>
                  </li>
                  <li>Manage
                    <ul>
                      <li><a href="file:///usr/local/share/xtrkcad/html/cmdTurnoutNew.html">Turnout
                          designer</a></li>
                      <li>Custom defined parts
                        <ul>
                          <li>Edit</li>
                        </ul>
                        <ul>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>Construcció del circuit / Build layout
                <ul>
                  <li>seleccioneu la via a dalt / select track on top</li>
                  <li>moveu-la a prop d'una via existent / move it next to
                    existing track</li>
                  <li>trieu-ne l'orientació fent: majúscula + clic esquerre /
                    choose end by: shift + left click</li>
                  <li>posicioneu-la amb la barra d'espai / fix it with space bar</li>
                </ul>
              </li>
              <li>Pan
                <ul>
                  <li>[shift+] arroy keys</li>
                  <li>View -&gt; Pan/Zoom</li>
                </ul>
              </li>
              <li>Selecció / Select
                <ul>
                  <li>Change -&gt; Select (Ctrl + E)</li>
                  <li>selecció de totes les vies connectades / select all
                    connected tracks
                    <ul>
                      <li>Shift: to select all segment</li>
                    </ul>
                  </li>
                  <li>selecció de vies individuals / select individual tracks:
                    <ul>
                      <li>Ctrl: to add tracks</li>
                    </ul>
                  </li>
                  <li>selecció de vies entre dues vies / select all tracks
                    between two tracks:
                    <ul>
                      <li>seleccioneu la primera via / select first track</li>
                      <li>seleccioneu amb CTRL l'última via / ctrl select last
                        track</li>
                      <li>seleccioneu amb majúscules totes les vies del mig /
                        shift to select all tracks in between</li>
                    </ul>
                  </li>
                  <li>unselect
                    <ul>
                      <li>ESC</li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>Move
                <ul>
                  <li>Change -&gt; Move (Shift + Ctrl + M)</li>
                </ul>
              </li>
              <li>Join
                <ul>
                  <li>movent / moving
                    <ul>
                      <li>select section</li>
                      <li>Change -&gt; Join tracks</li>
                      <li>Shift + click on end point of selected section</li>
                      <li>click on the other section</li>
                    </ul>
                  </li>
                  <li>afegint vies flexibles / adding flex tracks
                    <ul>
                      <li>select section</li>
                      <li>Change -&gt; Join tracks</li>
                      <li>click on end point of selected section</li>
                      <li>click on the other section</li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>Connect (slightly move all tracks to get a connection)
                <ul>
                  <li>Options -&gt; Preferences: Connection Distance</li>
                  <li>Change -&gt; Connect Two Tracks</li>
                </ul>
              </li>
              <li>Split
                <ul>
                  <li>Split track icon</li>
                </ul>
              </li>
              <li><a href="http://xtrkcad-fork.sourceforge.net/Wikka/IntoHills">Elevation</a>
                <ul>
                  <li>if you define an elevation at one point, all connected
                    tracks will have the same elevation (gold)</li>
                  <li>if you define elevation at two points, all connected
                    tracks will have calculated elevation (purple)
                    <ul>
                      <li>tracks beyond those point will maintain the elevation
                        (gold)</li>
                      <li>to display the grade of endpoints, set the elevation
                        endpoint as Grade</li>
                    </ul>
                  </li>
                  <li>Track elevations
                    <ul>
                      <li>gold: defined</li>
                      <li>purple: calculated</li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>Impressió / Print (File -&gt; Print)
                <ul>
                  <li>circuit en diverses pàgines / layout in several pages
                    <ul>
                      <li>Print Scale (tab to apply value; do not use enter)</li>
                      <li>Page Width, Height to define dimensions for each page
                        (Max to set it to maximum possible value for given Print
                        Scale)</li>
                      <li>Page Format to define orientation of selected part
                        (does not have any effect in final pdf orientation)</li>
                      <li>select wanted pages on layout (Select All to select
                        them all; Clear to unselect them all)</li>
                    </ul>
                  </li>
                  <li>tot el circuit en una pàgina / all layout in one single
                    page
                    <ul>
                      <li>Snap Shot</li>
                    </ul>
                  </li>
                  <li>etiqiuetes / labels
                    <ul>
                      <li>controlled by values in Options -&gt; Display
                        <ul>
                          <li>Two Rail Scale &lt; x (2x when printing)</li>
                          <li>Label Scale &lt;= y (y when printing, but you may
                            want to increase Label Font Size; if values do not
                            appear on display, they will not appear on print)</li>
                          <li>Label Font Size: must be, at least, the double of
                            Print Scale</li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="seccio-cap">
            <h2><a id="trens">Trens / Trains</a></h2>
          </td>
        </tr>
        <tr>
          <td class="seccio-fons">
            <ul>
              <li><a href="http://xtrkcad-fork.sourceforge.net/Wikka/RunningTrain?show_comments=1">Running
                  a train</a></li>
              <li>Exemples / Examples
                <ul>
                  <li>Help -&gt; Examples...: cascade.xtc</li>
                </ul>
              </li>
              <li>Parameters Files (app/lib/<a href="https://sourceforge.net/p/xtrkcad-fork/xtrkcad/ci/default/tree/app/lib/params/">params</a>/)
                <ul>
                  <li>
                    <table border="1">
                      <tbody>
                        <tr class="taula-cap">
                          <th>file</th>
                          <th>CONTENTS</th>
                          <th><a href="http://xtrkcad-fork.sourceforge.net/Wikka/FileFormats">CARPROTO</a></th>
                          <th><br>
                          </th>
                          <th><br>
                          </th>
                          <th><br>
                          </th>
                          <th><br>
                          </th>
                        </tr>
                        <tr class="taula-cap">
                          <th><br>
                          </th>
                          <th><br>
                          </th>
                          <th>loco<br>
                            <ul>
                              <li>Diesel (10101)</li>
                              <li>Steam (10201)</li>
                              <li>Electric (10301)</li>
                            </ul>
                          </th>
                          <th><a href="modelisme.html#lexic_vagons" class="intern">freight</a>
                            (30100)<br>
                            (<a href="https://web.archive.org/web/20111007195551/http://worldtraderef.com/WTR_site/Rail_Cars/Guide_to_Rail_Cars.asp">Guide
                              to railcars</a>)</th>
                          <th>passenger (50100)</th>
                          <th>Maintenance of Way (70100)</th>
                          <th>Other (90100)</th>
                        </tr>
                        <tr>
                          <td>br.xtp</td>
                          <td>British Rolling-stock Prototype Cars</td>
                          <td>
                            <ul>
                              <li>Diesel
                                <ul>
                                  <li>01 02 03 04 05 06 07 08 14 15 16 17 121
                                    141/142 143 150 153 156 158 20 31 33 33/2 37
                                    47 56 60 66 HST</li>
                                </ul>
                              </li>
                              <li>Electric
                                <ul>
                                  <li>73 85 86 87 90 91 </li>
                                </ul>
                              </li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li> CCT</li>
                              <li>GUV</li>
                              <li>POS</li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li> BG</li>
                            </ul>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>eu.xtp</td>
                          <td>European Rolling-Stock Prototype Cars</td>
                          <td>-</td>
                          <td>
                            <ul>
                              <li>Bogie Large Van (Cargowaggon) 20.8m</li>
                              <li>Twin RIV Van (use in pairs)</li>
                            </ul>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>protoam.xtp</td>
                          <td>North American Rolling-Stock Prototype Cars</td>
                          <td>
                            <ul>
                              <li>Diesel
                                <ul>
                                  <li>44t</li>
                                  <li>AC4400CW, AC6000CW</li>
                                  <li>AEM7</li>
                                  <li>C30-7</li>
                                  <li>Dash 8-40B, Dash 8-40BW, Dash 8-40C, Dash
                                    8-40CW</li>
                                  <li>DD-40X</li>
                                  <li>E8A</li>
                                  <li>F3A, F3B, F9A, F9B, FP7, F59PHI</li>
                                  <li>H15-44, H16-44, H15/16-44</li>
                                  <li>M420</li>
                                  <li>RS1, RS3, RS4/5, RS11, RSD12</li>
                                  <li>S1, S2, S3, S4</li>
                                  <li>SW7, SW9, SW1200</li>
                                  <li>U23B, U23C, U25B, U25C, U28C, U30B, U30C,
                                    U33B, U33C, U50C</li>
                                  <li>GP7, GP9, GP35, GP38, GP39, GP40, GP40-2</li>
                                  <li>SD35, SD38, SD39, SD40, SD40-2, SD40-2F,
                                    SD45, SD50, SD60, SD60M, SD70M, SD75M</li>
                                </ul>
                              </li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li><a href="https://en.wikipedia.org/wiki/Boxcar">Box</a>
                                (40, 50, 53, 60, 86)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Caboose">Caboose</a>
                                (34 Cupola, Ext Vision)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Gondola_%28rail%29">Gondola</a>
                                (42, 50, 65)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Flatcar">Flat</a>
                                (42, 50, 60, 89)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Hopper_car">Hopper</a>
                                (25, 30, 45, 67)</li>
                              <li><a href="www.americanrailcar.com/Manufacturing/CenterflowCars">Hopper,
                                  Centerflow</a> (36, 40, 50, 56)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Covered_hopper">Hopper,
                                  Covered</a> (35, 40, 50)</li>
                              <li>Hopper, Cyl (50, 56)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Refrigerator_car">Reefer</a>
                                (36, 40, 50, 57)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Stock_car_%28rail%29">Stock</a>
                                (40, 50, 60, 85)</li>
                              <li><a href="https://en.wikipedia.org/wiki/Tank_car">Tank</a>
                                (28, 39, 40, 55, 60, 65)</li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li>Coach (80)</li>
                            </ul>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>proto-ng.xtp</td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>protosteam.xtp</td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </li>
                  <li>Notes:
                    <ul>
                      <li>&nbsp;<code><a href="shell.html#awk" class="intern">awk</a>
                          'BEGIN {ORS=" "} $1 ~ /^CARPROTO/ &amp;&amp; $4 ~
                          /10101/ {gsub(/\"/,"",$2);print $2}' protoam.xtp</code></li>
                    </ul>
                  </li>
                  <li>...</li>
                </ul>
              </li>
              <li>Car inventory
                <ul>
                  <li>és un inventori real; si poseu un cotxe al circuit,
                    desapareixerà de la barra. Però podeu afegir tants cotxes
                    com calgui / this is a real inventory: if you place a car
                    onto the layout, it will disappear from the hot bar. But you
                    can add as many cars as you need</li>
                </ul>
              </li>
              <li>Posicionament d'un cotxe / Placing a car (Linux)
                <ol>
                  <li>seleccioneu el mode tren / select train mode</li>
                  <li>seleccioneu un cotxe a la barra / select one car on the
                    hot bar</li>
                  <li>moveu el cursor al circuit / move cursor to layout</li>
                  <li>feu clic amb el botó dret (noel deixeu anar) i moveu el
                    cursor (si no moveu el cursor, el cotxe no apareixerà) /
                    left-click (do not release) and move the cursor (if you do
                    not move the cursor, the car will not be displayed)</li>
                  <li>deixeu el cotxe allà on vulgueu / place the car where you
                    want</li>
                </ol>
              </li>
              <li>Desviaments / Turnouts
                <ul>
                  <li>shift + left click to change its position</li>
                </ul>
              </li>
              <li>Custom
                <ul>
                  <li>Manage -&gt; Custom defined parts
                    <ul>
                      <li>Car Prototype</li>
                      <li>Car Part</li>
                    </ul>
                  </li>
                  <li>Move
                    <ul>
                      <li>per a moure'l a un fitxer separat / to move to a
                        separate file (.xtp)</li>
                      <li>la primera vegada que es crea cal posar una etiqueta /
                        the first time it is created, a label must be entered</li>
                      <li>les properes vegades els elements s'afegiran al fitxer
                        / next times, items are added to the file</li>
                      <li>exemples / examples
                        <ul>
                          <li><a href="modelisme.html#programari_fpm" class="intern">francesc.pinyol.m</a>
                            / <a href="modelisme.html#xtrkcad-custom-fpm" class="intern">xtrkcad-custom-fpm</a>
                            <ul>
                              <li>proto-fpm.xtp</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>File format
                <ul>
                  <li>
                    <table border="1">
                      <tbody>
                        <tr>
                          <td>Create a new: Car prototype</td>
                          <td>cm for 1:1</td>
                          <td><br>
                          </td>
                          <td>
                            <ul>
                              <li>Car Length: 1524,000 (cm for 1:1 train)</li>
                              <li>Truck Centers: 1224,280</li>
                              <li>Width: 304,800</li>
                              <li>Center Offset: 0,000</li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li>Car Length: 2640,00 cm</li>
                            </ul>
                          </td>
                        </tr>
                        <tr>
                          <td>protoam.xtp</td>
                          <td>inches for 1:1</td>
                          <td>CARPROTO "Coach, 80'" 0 50100 960.000 120.000 0 0
                            842.000 992.000</td>
                          <td>CARPROTO "elec_1524" 2 10301 600.000 120.000 0 0
                            482.000 632.000</td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>inventory</td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>my_layout.xtc</td>
                          <td>inches for model (e.g. 1:160)</td>
                          <td>CAR 3 N "Unknown&nbsp;&nbsp;&nbsp; Coach,
                            80'&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
                            &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
                            &nbsp;&nbsp;&nbsp; " 512 50100 6.000 0.750 0 0 5.263
                            6.200 16744448 0.000 0.000 0 0 0 0 0 0 0 0 0 "" 492
                            0 40.088 65.418 60.000</td>
                          <td>CAR 12 N "Custom&nbsp;&nbsp;&nbsp;
                            elec_1524&nbsp;&nbsp;&nbsp; elec
                            1524&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
                            &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; " 518 10301
                            3.750 0.750 0 0 3.013 3.950 16744448 0.000 0.000 0 0
                            0 0 0 0 0 0 0 "" 518 0 57.067 58.858 270.000</td>
                          <td><br>
                          </td>
                        </tr>
                        <tr>
                          <td>measurement on layout</td>
                          <td><br>
                          </td>
                          <td>
                            <ul>
                              <li>Length: 15.240cm</li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li>Length: 9.520cm</li>
                              <li>Width: 1.905cm</li>
                            </ul>
                          </td>
                          <td>
                            <ul>
                              <li>Length: 16.5cm </li>
                            </ul>
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </li>
                  <li>12 inches = 1 foot</li>
                  <li>960 inches = 80 feet</li>
                  <li>...</li>
                </ul>
              </li>
              <li>Problemes / Problems
                <ul>
                  <li><a href="https://xtrackcad.groups.io/g/main/message/7790?p=,,,20,0,0,0::Created,,place+car+linux,20,2,0,35948959">Re:
                      MAC version; placing trains</a></li>
                  <li><a href="https://xtrackcad.groups.io/g/main/topic/how_do_you_get_trains_onto/35950958?p=,,,20,0,0,0::recentpostdate%2Fsticky,,,20,2,60,35950958">How
                      do you get trains onto the layout in Linux?</a></li>
                  <li><a href="https://bugs.launchpad.net/ubuntu/+source/xtrkcad/+bug/380339">can't
                      drag and drop train cars to track in ubuntu 9.04</a></li>
                </ul>
              </li>
              <li>...</li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="seccio-cap">
            <h2><a id="3d">3D</a></h2>
          </td>
        </tr>
        <tr>
          <td class="seccio-fons">
            <ul>
              <li>Viewers
                <ul>
                  <li><a href="http://mwik.altervista.org/">XTrackViewer</a>
                    <ul>
                      <li><a href="https://xtrackcad.groups.io/g/main/topic/75965564?p=Created%2C%2C%2C20%2C2%2C0%2C0">XtrackCad
                          3D</a> (XTrackCAD User Group)
                        <ul>
                          <li>XTrackCAD User Group
                            <ul>
                              <li><a href="https://xtrackcad.groups.io/g/main/topic/101579827#13599">3D
                                  Viewer Update</a> (5th Oct 2023)</li>
                              <li><a href="https://xtrackcad.groups.io/g/main/topic/75965564?p=Created%2C%2C%2C20%2C2%2C0%2C0">XtrackCad
                                  3D</a> (12th May 2022)</li>
                            </ul>
                          </li>
                          <li>Codi
                            <ul>
                              <li><span style="  font-family: monospace;">cd
                                  Xtrk3D</span>
                                <ul>
                                  <li><span style="   font-family: monospace;">ln
                                      -s Interface.h interface.h</span></li>
                                  <li><span style="    font-family: monospace;">ln
                                      -s Vertex.h vertex.h </span></li>
                                </ul>
                              </li>
                              <li><span style="  font-family: monospace;">dotnet
                                  build -v d </span></li>
                            </ul>
                          </li>
                          <li>Requisits
                            <ul>
                              <li>Mageia 9
                                <ul>
                                  <li><span style="font-family: monospace;"><span
                                        style="text-decoration: line-through;">sudo
                                        dnf install glm-devel lib64glew-devel</span>
                                    </span></li>
                                  <li><span style="font-family: monospace;">sudo
                                      dnf install lib64glew-devel </span></li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                          <li>Baixada / Download
                            <ul>
                              <li><a href="https://sourceforge.net/projects/xtrk3dviewer/files/source/">Xtrk3DViewer
                                  Files</a>
                                <ul>
                                  <li> <a href="https://sourceforge.net/projects/xtrk3dviewer/files/source/Xtrk3DViewer_0_12/Xtrk3DViewer_0_12_5_source.zip/download">Xtrk3DViewer_0_12_5_source.zip</a></li>
                                  <li><code>cd ~/Baixades/</code></li>
                                  <li><code>mv Xtrk3DViewer_0_12_5_source.zip
                                      ~/src/</code></li>
                                  <li><code>cd ~/src/</code></li>
                                  <li><code>unzip Xtrk3DViewer_0_12_5_source.zip</code></li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                          <li>Modificacions del codi font / Modifications on
                            source code
                            <ul>
                              <li>See: <a href="https://gitlab.com/francesc.pinyol.m/xtrk3dviewer/-/blob/main/linux_build.md">linux_build.md</a></li>
                              <li><code>cd ~/src/Xtrk3DViewer/ </code></li>
                              <li>init git
                                <ul>
                                  <li><code>git init</code></li>
                                  <li><code>git add .</code></li>
                                  <li><code>git commit -m "initial import"</code></li>
                                </ul>
                              </li>
                              <li>replace backslashes by slashes:
                                <ul>
                                  <li><code>sed -i '/^#include/ s*\\*/*g'
                                      */*.hpp</code></li>
                                  <li><code>sed -i '/^#include/ s*\\*/*g' */*.h</code></li>
                                  <li><span style="font-family: monospace;"><code>sed
                                        -i '/^#include/ s*\\*/*g' */*.cpp</code></span></li>
                                </ul>
                              </li>
                              <li>link header files so as when referenced in
                                different case an error is not raised:
                                <ul>
                                  <ul>
                                  </ul>
                                  <li><span style="   font-family: monospace;">ln
                                      -s </span><span style="   font-family: monospace;">Interface.h
                                      </span><span style="   font-family: monospace;"><span
                                        style="   font-family: monospace;"><span
                                          style="  font-family: monospace;">Xtrk3D/</span></span>interface.h</span>
                                    <ul>
                                    </ul>
                                  </li>
                                  <li><span style="    font-family: monospace;">ln
                                      -s </span><span style="    font-family: monospace;"><span
                                        style="  font-family: monospace;"></span>Vertex.h
                                      </span><span style="   font-family: monospace;"><span
                                        style="  font-family: monospace;">Xtrk3D/</span></span><span
                                      style="    font-family: monospace;"><span
                                        style="  font-family: monospace;"></span>vertex.h</span></li>
                                  <li><span style="     font-family: monospace;">ln
                                      -s misc.h </span><span style="    font-family: monospace;"></span><span
                                      style="   font-family: monospace;"><span style="  font-family: monospace;">Xtrk3D/</span></span><span
                                      style="    font-family: monospace;"><span
                                        style="  font-family: monospace;"></span>Misc.h</span></li>
                                  <li><span style="     font-family: monospace;">ln
                                      -s TrackPlan.h Xtrk3D/Trackplan.h </span>
                                    <ul>
                                    </ul>
                                  </li>
                                </ul>
                              </li>
                              <li>or replace references to the correct file:
                                <ul>
                                  <li><span style="font-family: monospace;">sed
                                      -i '/^#include/
                                      s*interface.h*Interface.h*g'
                                      */*.{cpp,h,hpp}</span></li>
                                  <li><span style=" font-family: monospace;">sed
                                      -i '/^#include/ s*vertex.h*Vertex.h*g'
                                      */*.{cpp,h,hpp}</span></li>
                                  <li><span style=" font-family: monospace;">sed
                                      -i '/^#include/ s*Misc.h*misc.h*g'
                                      */*.{cpp,h,hpp}</span></li>
                                  <li><span style=" font-family: monospace;">sed
                                      -i '/^#include/ s*</span><span style=" font-family: monospace;"><span
                                        style="     font-family: monospace;"><span
                                          style="     font-family: monospace;"></span>Trackplan</span>.h*</span><span
                                      style=" font-family: monospace;"><span style="     font-family: monospace;">TrackPlan</span>.h*g'
                                      */*.{cpp,h,hpp}</span></li>
                                </ul>
                              </li>
                              <li>other references to header files:
                                <ul>
                                  <li><code>sed -i 's*#include
                                      "../../zip/zip_file.hpp"*#include
                                      "zip/zip_file.hpp"*g'
                                      ./Xtrk3D/PolygonSet.cpp</code></li>
                                </ul>
                              </li>
                              <li>...</li>
                            </ul>
                          </li>
                          <li>Compilació
                            <ul>
                              <li><a href="https://github.com/pavelliavonau/cmakeconverter">cmakeconverter</a>
                                <ul>
                                  <li>...</li>
                                </ul>
                              </li>
                              <li><a href="https://github.com/roozbehid/dotnet-vcxproj">dotnet-vcxproj</a>
                                <ol>
                                  <li><a href="https://learn.microsoft.com/en-us/dotnet/core/install/linux">Install
                                      .NET on Linux</a>
                                    <ul>
                                      <li><a href="https://learn.microsoft.com/en-us/dotnet/core/install/linux-scripted-manual#scripted-install">Scripted
                                          install</a><br>
                                        <code></code></li>
                                      <li><a href="https://learn.microsoft.com/en-us/cpp/build/reference/vcxproj-file-structure?view=msvc-170">.vcxproj
                                          and .props file structure</a><br>
                                        <code></code></li>
                                      <li><code>echo 'export
                                          PATH="$HOME/.dotnet:${PATH}"'
                                          &gt;&gt;~/.bashrc</code></li>
                                    </ul>
                                  </li>
                                  <li>(once) clone repo:
                                    <ul>
                                      <li><code>cd ~/src/</code></li>
                                      <li><code>git clone
                                          https://github.com/roozbehid/dotnet-vcxproj.git</code></li>
                                    </ul>
                                  </li>
                                  <li>(once) install templates:
                                    <ul>
                                      <li><code>cd ~src/dotnet-vcxproj</code><br>
                                        <code></code></li>
                                      <li><code>dotnet <a href="https://learn.microsoft.com/en-us/dotnet/core/tools/dotnet-new">new</a>
                                          install GCC.Build.Template</code>
                                        <ul>
                                          <li>will install gccbuild template</li>
                                          <li>to list all installed templates
                                            <ul>
                                              <li><code>dotnet new list</code></li>
                                            </ul>
                                          </li>
                                        </ul>
                                      </li>
                                    </ul>
                                  </li>
                                  <li>go to your project
                                    <ul>
                                      <li><code>cd ~/src/Xtrk3DViewer/ </code></li>
                                      <li>modify the name of the configurations
                                        (Debug|x64 -&gt; LinuxDebug|x64):
                                        <ul>
                                          <li><code>sed -i
                                              's/Debug|x64/LinuxDebug|x64/g'
                                              Xtrk3DViewer.sln</code></li>
                                          <li><code>sed -i
                                              's/Debug|x64/LinuxDebug|x64/g'
                                              */*.vcxproj </code></li>
                                        </ul>
                                      </li>
                                      <li>or set environment variables:
                                        <ul>
                                          <li><span style="text-decoration: line-through;"><span
                                                style="font-family: monospace;">export
                                                SolutionDir=~/src/Xtrk3DViewer</span></span></li>
                                          <li><span style=" font-family: monospace;">export
                                              VCTargetsPath=.</span></li>
                                          <li><span style="  font-family: monospace;">export
                                              LANGUAGE=en </span></li>
                                        </ul>
                                      </li>
                                      <li>add AdditionalIncludeDirectories
                                        <ul>
                                          <li>./Xtrk3D/Xtrk3D.vcxproj
                                            <ul>
                                              <li><code>&nbsp;
                                                  &lt;ItemDefinitionGroup
                                                  Condition="'$(Configuration)|$(Platform)'=='LinuxDebug|x64'"&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;
                                                  &lt;ClCompile&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;PrecompiledHeader&gt;Use&lt;/PrecompiledHeader&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;WarningLevel&gt;Level3&lt;/WarningLevel&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;Optimization&gt;Disabled&lt;/Optimization&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;SDLCheck&gt;true&lt;/SDLCheck&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;PreprocessorDefinitions&gt;_DEBUG;_LIB;%(PreprocessorDefinitions)&lt;/PreprocessorDefinitions&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;ConformanceMode&gt;true&lt;/ConformanceMode&gt;<br>
                                                  <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;AdditionalIncludeDirectories&gt;../thirdparty&lt;/AdditionalIncludeDirectories&gt;</strong><br>
                                                  &nbsp;&nbsp;&nbsp;
                                                  &lt;/ClCompile&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;
                                                  &lt;Link&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;SubSystem&gt;Windows&lt;/SubSystem&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;GenerateDebugInformation&gt;true&lt;/GenerateDebugInformation&gt;<br>
                                                  &nbsp;&nbsp;&nbsp;
                                                  &lt;/Link&gt;</code></li>
                                            </ul>
                                          </li>
                                          <li>./Xtrk3DViewer/Xtrk3DViewer.vcxproj
                                            <ul>
                                              <li>...</li>
                                            </ul>
                                          </li>
                                        </ul>
                                      </li>
                                      <li>or replace references to the correct
                                        file:
                                        <ul>
                                          <li><span style="font-family: monospace;">sed
                                              -i '/^#include/
                                              s*interface.h*Interface.h*g'
                                              */*.{cpp,h,hpp}</span></li>
                                          <li><span style=" font-family: monospace;">sed
                                              -i '/^#include/
                                              s*vertex.h*Vertex.h*g'
                                              */*.{cpp,h,hpp}</span></li>
                                          <li><span style=" font-family: monospace;">sed
                                              -i '/^#include/ s*Misc.h*misc.h*g'
                                              */*.{cpp,h,hpp}</span></li>
                                          <li><span style=" font-family: monospace;">sed
                                              -i '/^#include/ s*</span><span style=" font-family: monospace;"><span
                                                style="     font-family: monospace;"><span
                                                  style="     font-family: monospace;"></span>Trackplan</span>.h*</span><span
                                              style=" font-family: monospace;"><span
                                                style="     font-family: monospace;">TrackPlan</span>.h*g'
                                              */*.{cpp,h,hpp}</span></li>
                                        </ul>
                                      </li>
                                      <li>other references to header files:
                                        <ul>
                                          <li><code>sed -i 's*#include
                                              "../../zip/zip_file.hpp"*#include
                                              "zip/zip_file.hpp"*g'
                                              ./Xtrk3D/PolygonSet.cpp</code></li>
                                        </ul>
                                      </li>
                                      <li><code>dotnet <a href="https://learn.microsoft.com/en-us/dotnet/core/tools/dotnet-new">new</a>
                                          gccbuild</code>
                                        <ul>
                                          <li>modificarà / will modify:
                                            <ul>
                                              <li><code>*/*.vcxproj</code></li>
                                            </ul>
                                          </li>
                                          <li>crearà / will create:
                                            <ul>
                                              <li><code>*/Microsoft.Cpp.Default.props</code></li>
                                              <li><code>*/project.json</code></li>
                                            </ul>
                                          </li>
                                        </ul>
                                      </li>
                                      <li><code>dotnet clean</code><code>
                                          -p:Configuration=LinuxDebug
                                          -p:Platform=x64</code><br>
                                        <span style="font-family: monospace;"></span></li>
                                      <li><code>dotnet <a href="https://learn.microsoft.com/en-us/dotnet/core/tools/dotnet-build">build</a>
                                          -v d -p:Configuration=LinuxDebug
                                          -p:Platform=x64</code><br>
                                        <span style="font-family: monospace;"></span></li>
                                      <li><span style="text-decoration: line-through;"><span
                                            style="font-family: monospace;">dotnet
                                            build -v d</span></span>
                                        <ul>
                                          <li>Problemes<span style=" font-family: monospace;"></span>
                                            <ul>
                                              <li><a href="https://github.com/roozbehid/dotnet-vcxproj/issues/21">Flags
                                                  look to not be properly passed
                                                  to compiler #21&nbsp;</a><span
                                                  style="  font-family: monospace;"></span></li>
                                              <li><span style="   font-family: monospace;">EarcutWrapper.cpp(45,85):
                                                  error : invalid use of
                                                  non-static member function
                                                  ‘glm::detail::tvec2&lt;T,
                                                  P&gt; glm::detail::tvec3&lt;T,
                                                  P&gt;::xy() const [with T =
                                                  float; glm::precision P =
                                                  glm::highp]’
                                                  [/disc/src/Xtrk3DViewer/Xtrk3D/Xtrk3D.vcxproj]</span></li>
                                              <li><code>cd Xtrk3D; g++
                                                  -fmax-errors=1000 -I
                                                  "../thirdparty" -D_DEBUG
                                                  -D_LIB -Wall -Wno-comment
                                                  -Wno-parentheses
                                                  -Wno-missing-braces
                                                  -Wno-write-strings
                                                  -Wno-unknown-pragmas
                                                  -Wno-attributes&nbsp;
                                                  -fpermissive -x c++ -g2
                                                  -gdwarf-2&nbsp; -m64&nbsp; -c
                                                  Trackplan.cpp -o
                                                  "obj/x64/LinuxDebug/Trackplan.o"</code></li>
                                              <ul>
                                                <li><code>Trackplan.cpp:425:68:
                                                    error: invalid use of member
                                                    function ‘glm::vec&lt;2, T,
                                                    Q&gt; glm::vec&lt;3, T,
                                                    Q&gt;::xy() const [with T =
                                                    float; glm::qualifier Q =
                                                    glm::packed_highp]’ (did you
                                                    forget the ‘()’ ?)<br>
                                                    &nbsp; 425
                                                    |&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                    float len =
                                                    glm::length(m2.xy - m1.xy);<br>
                                                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                    |&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                    ~~~^~</code></li>
                                              </ul>
                                              <li><a href="opengl.html#glm" class="intern">glm</a></li>
                                              <ul>
                                                <li>versions</li>
                                                <ul>
                                                  <li>thirdparty: GLM 0.9.5.4:
                                                    2014-06-21</li>
                                                </ul>
                                                <ul>
                                                  <li>Linux package: <code>glm-devel-0.9.9.8</code></li>
                                                </ul>
                                              </ul>
                                              <li>error: cannot bind non-const
                                                lvalue reference of type
                                                'Xtrk3D::Shape&amp;' to an
                                                rvalue of type 'Xtrk3D::Shape'</li>
                                              <ul>
                                                <li><a href="https://www.reddit.com/r/cpp_questions/comments/gpowby/lvaluervalue_error_in_g/">lvalue/rvalue
                                                    error in g++? </a></li>
                                              </ul>
                                              <li>swizzle</li>
                                              <ul>
                                                <li>error : invalid use of
                                                  non-static member function
                                                  'glm::detail::tvec2&lt;T,
                                                  P&gt; glm::detail::tvec4&lt;T,
                                                  P&gt;::xy() const</li>
                                                <li>e.g. segment.cpp L257 has
                                                  already parenthesis</li>
                                                <li>solution: use parenthesis
                                                  everywhere</li>
                                              </ul>
                                              <li>error : cannot bind non-const
                                                lvalue reference of type
                                                '...&amp;' to an rvalue of type
                                                ''</li>
                                              <ul>
                                                <li>solution: create a variable</li>
                                              </ul>
                                              <li>error : expected
                                                primary-expression before
                                                'struct' </li>
                                              <ul>
                                                <li><code>g++ -fmax-errors=1000
                                                    -I "../thirdparty" -D_DEBUG
                                                    -D_LIB -Wall -Wno-comment
                                                    -Wno-parentheses
                                                    -Wno-missing-braces
                                                    -Wno-write-strings
                                                    -Wno-unknown-pragmas
                                                    -Wno-attributes&nbsp;
                                                    -fpermissive -x c++ -g2
                                                    -gdwarf-2&nbsp; -m64&nbsp;
                                                    -c Structure.cpp -o
                                                    "obj/x64/LinuxDebug/Structure.o"</code></li>
                                                <li>solution: </li>
                                                <ul>
                                                  <li><code>struct CS(...) -&gt;
                                                      {...}</code></li>
                                                </ul>
                                              </ul>
                                              <li>error : cannot bind non-const
                                                lvalue reference of type
                                                'glm::vec3&amp;' {aka
                                                'glm::detail::tvec3&lt;float,
                                                glm::highp&gt;&amp;'} to an
                                                rvalue of type
                                                'glm::detail::tvec3&lt;float,
                                                glm::highp&gt;'</li>
                                              <ul>
                                                <li><code>g++ -fmax-errors=1000
                                                    -I "../thirdparty" -D_DEBUG
                                                    -D_LIB -Wall -Wno-comment
                                                    -Wno-parentheses
                                                    -Wno-missing-braces
                                                    -Wno-write-strings
                                                    -Wno-unknown-pragmas
                                                    -Wno-attributes&nbsp;
                                                    -fpermissive -x c++ -g2
                                                    -gdwarf-2&nbsp; -m64&nbsp;
                                                    -c track.cpp -o
                                                    "obj/x64/LinuxDebug/track.o"</code></li>
                                                <li>...</li>
                                              </ul>
                                              <li><span style="    font-family: monospace;">...
                                                  </span></li>
                                            </ul>
                                          </li>
                                        </ul>
                                      </li>
                                    </ul>
                                  </li>
                                </ol>
                              </li>
                              <li>monodevelop
                                <ul>
                                  <li>Open: Xtrk3DViewer.sln</li>
                                  <li>Problemes:
                                    <ul>
                                      <li>"This project type is not supported by
                                        MonoDevelop"
                                        <ul>
                                          <li>només suporta fitxers amb .net; no
                                            en c++</li>
                                          <li><a href="https://www.monodevelop.com/documentation/feature-list/">Feature
                                              list</a></li>
                                        </ul>
                                      </li>
                                    </ul>
                                  </li>
                                </ul>
                              </li>
                              <li>VSCode
                                <ul>
                                  <li>Instal·lació
                                    <ul>
                                      <li><a href="https://code.visualstudio.com/docs/setup/linux">Visual
                                          Studio Code on Linux</a>
                                        <ul>
                                          <li>Extensions
                                            <ul>
                                              <li>C/C++ Extension pack</li>
                                              <li>vscode-solution-explorer
                                                <ul>
                                                  <li><a href="https://github.com/fernandoescolar/vscode-solution-explorer/issues/116">&nbsp;How
                                                      to Add a
                                                      C++Project(.vcxproj)
                                                      directly in
                                                      vscode-solution-explorer
                                                      #116 </a></li>
                                                </ul>
                                              </li>
                                            </ul>
                                          </li>
                                        </ul>
                                      </li>
                                      <li><a href="https://learn.microsoft.com/en-us/dotnet/core/install/linux">Install
                                          .NET on Linux</a>
                                        <ul>
                                          <li><code>echo 'export
                                              PATH="$HOME/.dotnet:${PATH}"'
                                              &gt;&gt;~/.bashrc</code></li>
                                        </ul>
                                      </li>
                                    </ul>
                                  </li>
                                  <li>...</li>
                                </ul>
                              </li>
                              <li>DEPRECATED: <code>xbuild Xtrk3D.vcxproj</code>
                                <ul>
                                  <li><span style="font-family: monospace;">sudo
                                      dnf install mono-devel</span></li>
                                </ul>
                              </li>
                              <li><code>msbuild Xtrk3D.vcxproj</code>
                                <ul>
                                  <li><span style="font-family: monospace;">sudo
                                      dnf ?</span></li>
                                </ul>
                              </li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </li>
              <li>DXF
                <ul>
                  <li>select all tracks to be exported </li>
                  <li>Export <a href="opengl.html#dxf" class="intern">DXF</a> </li>
                  <li>Use a <a class="intern" href="opengl.html#cad">CAD
                      program</a> (e.g. <a href="opengl.html#blender" class="intern">Blender</a>
                    + <a href="opengl.html#blender_dxf" class="intern">DWG/DXF
                      plugin</a>, FreeCAD) </li>
                  <li><a href="#xtrkcad_feature_requests" class="intern">Feature
                      requests</a></li>
                  <li>Fork
                    <ul>
                      <li><a href="#xtrkcad_forks" class="intern">cescp /
                          xtrkcad-fork</a></li>
                    </ul>
                  </li>
                </ul>
              </li>
            </ul>
          </td>
        </tr>
        <tr>
          <td class="peu" style="vertical-align: top;">
            <p style="font-size: smaller; text-align: center;">
              http://www.francescpinyol.cat/.html<br>
              Primera versió: / First version: 2.I.2021<br>
              Darrera modificació: 2 de juny de 2024 / Last update: 2nd June
              2024</p>
            <p style="text-align: center;"> <a href="http://validator.w3.org/check/referer">
                <img src="//www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01!"
                  style="border-style: hidden;" width="88" height="31"> </a> </p>
            Cap a <a href="index.html" class="intern">casa</a> / Back <a href="index.html"
              class="intern">home</a>. </td>
        </tr>
      </tbody>
    </table>
  </body>
</html>
